local _,ns = ...
local L=ns.L
ns.itemCached = {}

local AutoScrap = CreateFrame("Frame")  --se puede crear como global para compartirlo con otros addons. el tipo frame puede recibir ciertas señales, por eso se crea genérico.
-- global char variable: AutoScrap_CharSettings
--print("desde core: "..AutoScrap_CharSettings.cantidad)
ns.PLAYER_ENTERING_WORLD = false
local scrapIventory
local scrapSingleItem

AutoScrap:RegisterEvent("PLAYER_ENTERING_WORLD");
AutoScrap:RegisterEvent("ADDON_LOADED");
AutoScrap:RegisterEvent("PLAYER_LOGIN");
AutoScrap:RegisterEvent("GET_ITEM_INFO_RECEIVED");
AutoScrap:RegisterEvent("BAG_UPDATE"); --cambio en bolsas, se puede lanzar varias veces si mueves de una bolsa a otra
--AutoScrap:RegisterEvent("BAG_UPDATE_COOLDOWN"); -- se recibe cada 20 segundos sin argumentos
AutoScrap:RegisterEvent("PLAYER_LEAVING_WORLD");
local checkItemIdLater = {}

local comprobarWhiteList
local function eventHandler (self, event, ...)
    if event == "PLAYER_ENTERING_WORLD" then
        ns.PLAYER_ENTERING_WORLD = true
        comprobarWhiteList()
        ns.itemCached={}
        if IsAddOnLoaded("FasterLoot") or IsAddOnLoaded("FasterLooting") then
            ns.otroAddonFasterLootDetectado()
        end
    elseif event == "ADDON_LOADED" then
        ns.variablesCargadas(...)
        ns.itemCached={}
        if AutoScrap_CharSettings.autoscrapOn then
            scrapIventory()
        end

    elseif event == "PLAYER_LOGIN" then
        ns.miniMapLoad()
        ns.PLAYER_LOGIN = true
    elseif event == "GET_ITEM_INFO_RECEIVED" then --itemID, boolean recibido con éxito
        --print ("GET_ITEM_INFO_RECEIVED",...)
        local item, exito = ...
        if exito and checkItemIdLater[item] then
            scrapIventory()
            checkItemIdLater[item] = nil
        end
    elseif event == "BAG_UPDATE" then
        --print ("BAG_UPDATE",...)
        scrapIventory()
    --[[ elseif event == "BAG_UPDATE_COOLDOWN" then
        --print ("BAG_UPDATE_COOLDOWN",...)
       scrapIventory() ]]
    elseif event == "PLAYER_LEAVING_WORLD" then
        ns.PLAYER_ENTERING_WORLD = false
    end
end
AutoScrap:SetScript("OnEvent", eventHandler)

local function handle_commands(msg)
    --print("Recibido el comando: " .. msg)
    local separarPalabras = {}
    for substring in msg:gmatch("%S+") do
        table.insert(separarPalabras, substring)
    end
    --msg = {msg}
    if separarPalabras[1] == nil then --puesto /scrap o /autoscrap
        --print ("scrapeando -> cantidad: " .. scrapear_char.cantidad .. " " .. scrapear_char.TSM_mercado .. " 2Mercados: " .. tostring(scrapear_char.usar2Mercados))
        ns.mostrarFrames()
    elseif separarPalabras[1] == "clear" then --puesto /scrap clear o /autoscrap clear

        --limpiarMonedas()
    elseif separarPalabras[1] == "test" then


        --[[ local itemID = select(10,GetContainerItemInfo(0,1))
        local result = {}
        result = TSM_API.GetPriceSourceKeys(result)
        for k,v in pairs(result)do
            local data = TSM_API.GetCustomPriceValue(v, "i:"..itemID)
            print (v, data)
        end ]]

        --[[ local itemID = select(10,GetContainerItemInfo(0,1))
        local result = {}
        result = TSM_API.GetPriceSourceKeys(result)
        for k,v in pairs(result)do
            local data = TSM_API.GetCustomPriceValue(v, "i:"..itemID)
            print (v, data)
        end ]]



        --[[ for b = 0, 4 do
            for i = 1, GetContainerNumSlots(b) do
                local itemID = select(10,GetContainerItemInfo(b,i))
                if itemID then local result = TSM_API.GetCustomPriceValue("DBRegionSoldPerDay", "i:"..itemID)
                print (result)end
            end
        end ]]
        --local zz=select(7,GetContainerItemInfo(0,1)) print(GetItemInfo(zz))
    else
        --mensaje de ayuda
    end
end

SlashCmdList["AUTOSCRAP"] = function(msg) handle_commands(msg) end
SLASH_AUTOSCRAP1 = "/autoscrap"
SLASH_AUTOSCRAP2 = "/scrap"

local function comprobarOtrosAddons()
    if not TSM_API then
        ns.fatalErrorFunction(L["|cffff0000No|r |cff00ff00TSM 4|r |cffff0000 found|r"],L["|cffff0000https://www.tradeskillmaster.com/install|r"])
        return
    elseif not Scrap then
        ns.fatalErrorFunction(L["|cffff0000No addon|r |cff00ff00Scrap|r |cffff0000found, we need it also appart of AutoScrap"],L["|cffff0000https://www.curseforge.com/wow/addons/scrap|r"])
        return
    elseif not (SlashCmdList["SCRAPEAR"] == nil) then
        ns.fatalErrorFunction(L["Old 'Scrapear' files instalation still present"],L["Delete the folder 'Scrapear' in the _retail_/Interface/AddOns folder of WoW"])
    end
end

local function AutoScrapToggleJunk(itemID,classID,subClassID,bag,slot,itemLink,typeItem)
    if ns.CheckItemTypeSubtype(classID,subClassID) then
        local noVender = false
        local itemLevel = GetDetailedItemLevelInfo(itemLink)
        --if itemLevel==nil then print(itemLevel, nil)end
        local rate=TSM_API.GetCustomPriceValue("dbregionsalerate * 100", "i:" .. itemID) -- no todoslos objetos tienen rate
        --
        --print(itemID,itemLink,typeItem,itemLevel)
        if typeItem == "any" then--usar rates e ilevel genérico
            if rate and AutoScrap_CharSettings.protectedRatio and tonumber(rate) and (tonumber(rate)/100)>= AutoScrap_CharSettings.sellRatio then
                noVender= true
            end
            --ahora lo cambio sólo por items armor y weapon.
            if (classID == 4 or classID == 2) and itemLevel and AutoScrap_CharSettings.protectedIlevel and itemLevel >= AutoScrap_CharSettings.iLevel then
                noVender = true
            end
        else --usar rates a ilevel del tipo escogido en particular
            if typeItem == "ring" then
                --print("ring",itemID,itemLink,typeItem,rate,AutoScrap_CharSettings.ringsRate)
                if rate and tonumber(rate) and (tonumber(rate)/100)>= AutoScrap_CharSettings.ringsRate then
                    noVender = true
                end
                if itemLevel and itemLevel >= AutoScrap_CharSettings.ringsiLevel then
                    noVender = true
                end
            elseif typeItem == "gris" then
                if rate and tonumber(rate) and (tonumber(rate)/100)>= AutoScrap_CharSettings.graysRate then
                    noVender = true
                end
                if itemLevel and itemLevel >= AutoScrap_CharSettings.graysiLevel then
                    noVender = true
                end
            elseif typeItem == "blanco" then
                if rate and tonumber(rate) and (tonumber(rate)/100)>= AutoScrap_CharSettings.whitesRate then
                    noVender = true
                end
                if itemLevel and itemLevel >= AutoScrap_CharSettings.whitesiLevel then
                    noVender = true
                end
            end
        end
        --
        --aplicar
        if not noVender then
            if AutoScrap_CharSettings.protectSouldBinds then
                ns.itemCached[itemLink]= false
                local item = Item:CreateFromBagAndSlot(bag, slot)--para soulbind quitar comentado
                item:ContinueOnItemLoad(function()
                    ns.itemCached[itemLink]= true
                    local location = item:GetItemLocation()
                    local isSoulbound = C_Item.IsBound(location)
                    if not isSoulbound then
                        Scrap:ToggleJunk(itemID)
                    end
                end)
            else
                Scrap:ToggleJunk(itemID)
            end
        end
    end
end

scrapIventory = function ()
    if ns.PLAYER_ENTERING_WORLD then
        comprobarOtrosAddons()
        if not ns.fatalError then
            if AutoScrap_CharSettings.autoscrapOn then
                for b = 0, 4 do
                    for i = 1, GetContainerNumSlots(b) do
                        --local v = {GetContainerItemInfo(b, i)}
                        local bag,slot = b,i
                        local itemLink = GetContainerItemLink(b,i)
                        if not ns.itemCached[itemLink] then
                            local itemID = GetContainerItemID(b,i)
                            if itemID and itemLink and itemID == 180653 then
                                ns.itemCached[itemLink] = true
                            end
                            --local icon, itemCount, locked, quality, readable, lootable, itemLink, isFiltered, noValue, itemID = GetContainerItemInfo(b, i)
                            --if v and v[4] == -1 then print("item quality -1 received") end -- nos guardamos esto para saber que no lo ha cargado bien.
                            if itemLink and itemID then
                                --print("attemp-> "  .. v[7].. " id:" ..v[10] )
                                local stringComparacion
                                if (TSM_API.GetGroupPathByItem("i:"..itemID)) then
                                    stringComparacion = string.upper(TSM_API.GetGroupPathByItem("i:"..itemID))
                                    _,stringComparacion = TSM_API.SplitGroupPath(stringComparacion)
                                end
                                if not (stringComparacion == string.upper("No Vender") or stringComparacion == string.upper("NoVender") or stringComparacion == string.upper("#No Vender")) then
                                    --añadir aquí ahora el grupo de no vender
                                    local whiteListed = false
                                    for x,y in pairs (AutoScrap_CharSettings.noVenderList) do --mejor con itemlink? variaciones de items
                                        if x == itemID then
                                            whiteListed = true
                                        end
                                    end
                                    if not whiteListed then
                                        local valorMercadoComparacion
                                        local skip = false
                                        if not AutoScrap_CharSettings.usar2Mercados then
                                            valorMercadoComparacion = TSM_API.GetCustomPriceValue(AutoScrap_CharSettings.TSM_mercado, "i:" .. itemID)
                                            if not valorMercadoComparacion then
                                                skip = true
                                            end
                                        else
                                            local valordbmarket = TSM_API.GetCustomPriceValue("dbmarket", "i:" .. itemID)
                                            local valordbregionmarketavg = TSM_API.GetCustomPriceValue("dbregionmarketavg", "i:" .. itemID)
                                            if not valordbmarket then
                                                skip = true
                                            end
                                            if not valordbregionmarketavg then
                                                skip = true
                                            end
                                            if not skip then
                                                if  valordbmarket > valordbregionmarketavg  then
                                                    valorMercadoComparacion = valordbmarket
                                                else
                                                    valorMercadoComparacion = valordbregionmarketavg
                                                end
                                            end
                                        end
                                        --if skip = true no tiene valor de mercado. valor de meracdo es que tiene valor
                                        -- /run za=select(7,GetContainerItemInfo(0,1))  zz=select(11,GetItemInfo(za)) print(zz/10000)

                                        --Añadir precio de npc si no tiene precio de mercado
                                        local uno,dos,calidadEquipo,itemLevel,cinco,seis,siete,ocho,slotEquipar,diez,sellPrice,classID,subClassID,catorce,quince,diceciseis,diecisiete = GetItemInfo(itemLink)
                                        if uno and calidadEquipo and slotEquipar and sellPrice and classID and subClassID then
                                            ns.itemCached[itemLink]= true
                                            --print ("Cached: ", itemLink)
                                        else
                                            --print ("Uncached: ", itemLink)
                                        end
                                        if skip and sellPrice and sellPrice>0  and (classID == 4 or classID==2)then
                                            skip=false
                                            valorMercadoComparacion=sellPrice
                                            --print ("no market value and sell price for: ",itemLink,sellPrice/10000)
                                        end

                                        --quitar de la lista ahora que no se usa skip para para evitar vender la lista de No vender. Tener en cuenta quel el grupo de tsm no vender ya ni pasa por aquí
                                        
                                    
                                        if not skip then
                                            -- lógica de venta
                                            --print(v[7],v[10])
                                            
                                            --if itemID and itemID == 6268 then print(itemID,itemLevel,itemLink) end
                                            if uno then
                                                if (classID==4 and subClassID == 0 and AutoScrap_CharSettings.venderAnillos and (slotEquipar == "INVTYPE_FINGER" or slotEquipar == "INVTYPE_TRINKET" or slotEquipar == "INVTYPE_NECK"))then  --vender anillos trinkers y abalorios siempre
                                                    --print("Anillo:",itemLink)
                                                        local saltar = false
                                                        if (valorMercadoComparacion / 10000 ) >= AutoScrap_CharSettings.ringsGold then
                                                            saltar = true
                                                            --print("valor mercado saltar")
                                                        end--añadir anillo aqí tb si salta
                                                        if not saltar then
                                                            if not Scrap:IsJunk(itemID) then
                                                                --print("Toggle-> "  .. v[7].. " id:" ..v[10] )
                                                                AutoScrapToggleJunk(itemID,classID,subClassID,bag,slot,itemLink,"ring")
                                                                --print("eliminado")
                                                            end
                                                        end
                                                elseif ((classID == 4 or classID == 2) and AutoScrap_CharSettings.venderGrises and calidadEquipo==0)then --vender armaduras y armas grises
                                                    --print("Gris:",itemLink)
                                                        local saltar = false
                                                        if (valorMercadoComparacion / 10000 ) >= AutoScrap_CharSettings.graysGold then
                                                            saltar = true
                                                        end
                                                        if not saltar then
                                                            if not Scrap:IsJunk(itemID) then
                                                                AutoScrapToggleJunk(itemID,classID,subClassID,bag,slot,itemLink,"gris")
                                                            end
                                                        end
                                                elseif ((classID == 4 or classID == 2) and AutoScrap_CharSettings.venderBlancos and calidadEquipo==1)then --vender armaduras y armas blancas
                                                    --print("blanco:",itemLink)
                                                        local saltar = false
                                                        if (valorMercadoComparacion / 10000 )>= AutoScrap_CharSettings.whitesGold then
                                                            saltar = true
                                                        end
                                                        if not saltar then
                                                            if not Scrap:IsJunk(itemID) then
                                                                AutoScrapToggleJunk(itemID,classID,subClassID,bag,slot,itemLink,"blanco")
                                                            end
                                                        end
                                                elseif ( valorMercadoComparacion / 10000 ) < AutoScrap_CharSettings.cantidad then  -- vender si menor del precio
                                                    --print("any:",itemLink)
                                                    if not Scrap:IsJunk(itemID) then
                                                        AutoScrapToggleJunk(itemID,classID,subClassID,bag,slot,itemLink,"any")
                                                    end
                                                end

                                            -- fin lógica de venta
                                            else --GetItemInfo failed
                                                checkItemIdLater[itemID] = true
                                            end -- 
                                        end
                                        skip = false
                                    end
                                end
                            else
                                --print("attemp-> nill")
                            end
                            --::continue::
                        end -- fin if cached itemlink
                    end
                end
            end
        end
    end
end
ns.scrapIventory = scrapIventory

--[[ scrapSingleItem = function ()
    if ns.PLAYER_ENTERING_WORLD then
        comprobarOtrosAddons()
        if not ns.fatalError then
            if AutoScrap_CharSettings.autoscrapOn then
                
            end
        end
    end
end ]]

comprobarWhiteList = function ()
    for k,v in pairs(AutoScrap_CharSettings.noVenderList) do
        if Scrap and Scrap:IsJunk(k) then
            Scrap:ToggleJunk(k)
        end
    end
end
ns.comprobarWhiteList = comprobarWhiteList
ASGlobal = comprobarWhiteList

local function limpiarMonedas()
    for b = 0, 4 do
        for i = 1, GetContainerNumSlots(b) do
            local icon, itemCount, locked, quality, readable, lootable, itemLink, isFiltered, noValue, itemID = GetContainerItemInfo(b, i)
            if icon and itemCount and itemLink and itemID then
                if Scrap:IsJunk(itemID) then
                    Scrap:ToggleJunk(itemID)
                end
            end
        end
    end
end
ns.limpiarMonedas = limpiarMonedas