local _,ns =...

ns.frameContent = nil
ns.frameContentName = nil
ns.Utils = {}
local tabs = {}

function ns.Utils.crearFrameConTextura (parentFrame, left, right, top, bottom, alfa,...)
    local frame = CreateFrame("Frame",nil, parentFrame)
    local texName = ...
    frame:SetSize(right-left,bottom-top)
    frame.tex = frame:CreateTexture()
    frame.tex:SetAllPoints(frame)
    if not texName then
        frame.tex:SetTexture("Interface\\AddOns\\AutoScrap\\images\\iconos")
    else
        frame.tex:SetTexture("Interface\\AddOns\\AutoScrap\\images\\"..texName)
    end
    frame.tex:SetTexCoord(left/512, right/512, top/512 , bottom/512);
    if alfa ~= 1 then
        frame.tex:SetVertexColor(1, 1, 1 , alfa);
    end
    return frame
end

local tabOnClick = nil
local tabMainWindowEnabled,tabMainWindowDisabled,tabNoVenderEnabled,tabNoVenderDisabled,tabProtectedEnabled,tabProtectedDisabled,tabConfigEnabled,tabConfigDisabled = nil,nil,nil,nil,nil,nil,nil,nil

function ns.AttachFrameTabs (parentFrame)
    local offsetDisabledFrame = 7
    local tabDistance = 29
    tabMainWindowEnabled = ns.Utils.crearFrameConTextura(parentFrame,414,438,0,26,1) 
    tabMainWindowEnabled:SetPoint("TOPLEFT", parentFrame, "TOPRIGHT",-3,-36)-- 4,-24
    tabMainWindowDisabled = ns.Utils.crearFrameConTextura(parentFrame,414+offsetDisabledFrame,438,0,26,1)
    tabMainWindowDisabled:SetPoint("TOPLEFT", parentFrame, "TOPRIGHT",-3,-36)
    tabMainWindowDisabled:SetScript("OnMouseUp", tabOnClick)
    tabMainWindowDisabled:Hide()
    tabNoVenderEnabled = ns.Utils.crearFrameConTextura(parentFrame,438,462,0,26,1)
    tabNoVenderEnabled:SetPoint("TOPLEFT", parentFrame, "TOPRIGHT",-3,-36-tabDistance)
    tabNoVenderEnabled:Hide()
    tabNoVenderDisabled = ns.Utils.crearFrameConTextura(parentFrame,438+offsetDisabledFrame,462,0,26,1)
    tabNoVenderDisabled:SetPoint("TOPLEFT", parentFrame, "TOPRIGHT",-3,-36-tabDistance)
    tabNoVenderDisabled:SetScript("OnMouseUp", tabOnClick)
    tabProtectedEnabled = ns.Utils.crearFrameConTextura(parentFrame,462,487,0,26,1)
    tabProtectedEnabled:SetPoint("TOPLEFT", parentFrame, "TOPRIGHT",-3,-36-tabDistance*2)
    tabProtectedEnabled:Hide()
    tabProtectedDisabled = ns.Utils.crearFrameConTextura(parentFrame,462+offsetDisabledFrame,487,0,26,1)
    tabProtectedDisabled:SetPoint("TOPLEFT", parentFrame, "TOPRIGHT",-3,-36-tabDistance*2)
    tabProtectedDisabled:SetScript("OnMouseUp", tabOnClick)
    tabConfigEnabled = ns.Utils.crearFrameConTextura(parentFrame,487,511,0,26,1)
    tabConfigEnabled:SetPoint("TOPLEFT", parentFrame, "TOPRIGHT",-3,-36-tabDistance*8)
    tabConfigEnabled:Hide()
    tabConfigDisabled = ns.Utils.crearFrameConTextura(parentFrame,487+offsetDisabledFrame,511,0,26,1)
    tabConfigDisabled:SetPoint("TOPLEFT", parentFrame, "TOPRIGHT",-3,-36-tabDistance*8)
    tabConfigDisabled:SetScript("OnMouseUp", tabOnClick)
end


function ns.FrameSetup(frame, frameString)
    if tabs == nil then
        ns.frameContent=frame
        ns.frameContentName=frameString
    end
    tabs[frameString] = frame
end

function tabOnClick(...) --self, button, true/false
    local tab, button, directInput = ...
    if directInput and button == "LeftButton" then
        if tab == tabMainWindowDisabled then
            tabMainWindowEnabled:Show()
            tabMainWindowDisabled:Hide()
            tabNoVenderEnabled:Hide()
            tabNoVenderDisabled:Show()
            tabProtectedEnabled:Hide()
            tabProtectedDisabled:Show()
            tabConfigEnabled:Hide()
            tabConfigDisabled:Show()
            ns.frameContent=tabs["MainWindow"]
            ns.frameContentName="MainWindow"
            tabs["MainWindow"]:Show()
            tabs["NoVender"]:Hide()
            tabs["Protected"]:Hide()
            tabs["Config"]:Hide()
        elseif tab == tabNoVenderDisabled then
            tabMainWindowEnabled:Hide()
            tabMainWindowDisabled:Show()
            tabNoVenderEnabled:Show()
            tabNoVenderDisabled:Hide()
            tabProtectedEnabled:Hide()
            tabProtectedDisabled:Show()
            tabConfigEnabled:Hide()
            tabConfigDisabled:Show()
            ns.frameContent=tabs["NoVender"]
            ns.frameContentName="NoVender"
            tabs["NoVender"]:Show()
            tabs["MainWindow"]:Hide()
            tabs["Protected"]:Hide()
            tabs["Config"]:Hide()
        elseif tab == tabProtectedDisabled then
            tabMainWindowEnabled:Hide()
            tabMainWindowDisabled:Show()
            tabNoVenderEnabled:Hide()
            tabNoVenderDisabled:Show()
            tabProtectedEnabled:Show()
            tabProtectedDisabled:Hide()
            tabConfigEnabled:Hide()
            tabConfigDisabled:Show()
            ns.frameContent=tabs["Protected"]
            ns.frameContentName="Protected"
            tabs["NoVender"]:Hide()
            tabs["MainWindow"]:Hide()
            tabs["Protected"]:Show()
            tabs["Config"]:Hide()
        elseif tab == tabConfigDisabled then
            tabMainWindowEnabled:Hide()
            tabMainWindowDisabled:Show()
            tabNoVenderEnabled:Hide()
            tabNoVenderDisabled:Show()
            tabProtectedEnabled:Hide()
            tabProtectedDisabled:Show()
            tabConfigEnabled:Show()
            tabConfigDisabled:Hide()
            ns.frameContent=tabs["Config"]
            ns.frameContentName="Config"
            tabs["NoVender"]:Hide()
            tabs["MainWindow"]:Hide()
            tabs["Protected"]:Hide()
            tabs["Config"]:Show()
        end
    end
end

local function tabToMainForFatalError()
    tabMainWindowEnabled:Hide()
    tabMainWindowDisabled:Hide()
    tabNoVenderEnabled:Hide()
    tabNoVenderDisabled:Hide()
    tabProtectedEnabled:Hide()
    tabProtectedDisabled:Hide()
    tabConfigEnabled:Hide()
    tabConfigDisabled:Hide()
    ns.frameContent=tabs["MainWindow"]
    ns.frameContentName="MainWindow"
    tabs["MainWindow"]:Show()
    tabs["NoVender"]:Hide()
    tabs["Protected"]:Hide()
    tabs["Config"]:Hide()
end
ns.tabToMainForFatalError=tabToMainForFatalError
