local _,ns = ...
local z = ns.Utils.crearFrameConTextura(ns.f,3,215,0,331,1)
z:SetPoint("CENTER", ns.f, "CENTER")
ns.FrameSetup(z,"Config")

local function setTooltip(parentFrame,...)
    local text1,text2,text3,text4=...
    parentFrame:HookScript("OnEnter", function(self)
        GameTooltip:SetOwner( parentFrame, "ANCHOR_NONE" );
        GameTooltip:SetPoint("TOPLEFT", z, "BOTTOMLEFT", -2, -4)
        if text1 then
        --print(HIGHLIGHT_FONT_COLOR_CODE..text1..FONT_COLOR_CODE_CLOSE)
            GameTooltip:AddLine(NORMAL_FONT_COLOR_CODE..text1..FONT_COLOR_CODE_CLOSE,1,0,0,true)
        end
        if text2 then
            GameTooltip:AddLine(HIGHLIGHT_FONT_COLOR_CODE..text2..FONT_COLOR_CODE_CLOSE,1,0,0,true)
        end
        if text3 then
            GameTooltip:AddLine(HIGHLIGHT_FONT_COLOR_CODE..text3..FONT_COLOR_CODE_CLOSE,1,0,0,true)
        end
        if text4 then
            GameTooltip:AddLine(HIGHLIGHT_FONT_COLOR_CODE..text4..FONT_COLOR_CODE_CLOSE,1,0,0,true)
        end
        --AutoScrapTooltip:AddDoubleLine("prob", "lala")
        GameTooltip:Show()
    end)
    parentFrame:HookScript("OnLeave", function(self)
        GameTooltip:Hide()
    end)
end

z.c = CreateFrame("Button", nil, z)
z.c:SetNormalTexture(130832) --"Interface\\Buttons\\UI-Panel-MinimizeButton-Up"
z.c:SetPushedTexture(130830) --"Interface\\Buttons\\UI-Panel-MinimizeButton-Down"
z.c:SetHighlightTexture(130831) --"Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight"
z.c:SetSize(32, 32)
z.c:SetPoint("TOPRIGHT", z, "TOPRIGHT", 0, -3)
z.c:SetScript("OnClick", function() ns.ocultarFrames() end)

z.title = ns.Utils.crearFrameConTextura(z,283,451,402,466,1)
z.title:SetPoint("TOP", z, "TOP", -3, -25)

local checkAutoLoot = CreateFrame("CheckButton", nil, z, "UICheckButtonTemplate");
checkAutoLoot:SetPoint("TOPLEFT", z.title, "BOTTOMLEFT", 10, 1);
checkAutoLoot.text:SetText(L["Faster AutoLoot"]);
checkAutoLoot:SetScript("OnClick", function (self)
    AutoScrap_CharSettings.AutoLoot = self:GetChecked()
    ns.enableAutoLoot(self:GetChecked())
end)

local textOtroAutoLoot = checkAutoLoot:CreateFontString (nil, "OVERLAY", "GameFontHighlightSmall")
textOtroAutoLoot:SetPoint("TOPLEFT", checkAutoLoot, "TOPLEFT", 39, -21)
textOtroAutoLoot:SetText(L["|cffd20a07Another Fasterloot\nDetected|r"])
textOtroAutoLoot:Hide()

checkAutoLoot.tachado = CreateFrame("Frame",nil,checkAutoLoot)
checkAutoLoot.tachado:SetSize(145,1)
checkAutoLoot.tachado:SetPoint("LEFT",checkAutoLoot,"LEFT",2,0)
checkAutoLoot.tachado.tex = checkAutoLoot.tachado:CreateTexture()
checkAutoLoot.tachado.tex:SetAllPoints(checkAutoLoot.tachado)
checkAutoLoot.tachado.tex:SetColorTexture(255/255, 0/255, 0/255 , 1); --rgb
checkAutoLoot.tachado:Hide()

local tooltipTextOtroAutoLoot = CreateFrame("Frame",nil,checkAutoLoot.tachado)
tooltipTextOtroAutoLoot:SetPoint("TOPLEFT",checkAutoLoot,"TOPLEFT")
tooltipTextOtroAutoLoot:SetPoint("RIGHT",checkAutoLoot.tachado,"RIGHT")
tooltipTextOtroAutoLoot:SetPoint("BOTTOM",textOtroAutoLoot,"BOTTOM")
tooltipTextOtroAutoLoot:Hide()

local function otroAddonFasterLootDetectado()
    checkAutoLoot:Disable()
    checkAutoLoot.tachado:Show()
    textOtroAutoLoot:Show()
    tooltipTextOtroAutoLoot:Show()
    ns.enableAutoLoot(false)
end
ns.otroAddonFasterLootDetectado = otroAddonFasterLootDetectado

local function setAutoLoot (value)
    checkAutoLoot:SetChecked(value)
    ns.enableAutoLoot(value)
end
ns.setAutoLoot = setAutoLoot

z:Hide()

setTooltip(checkAutoLoot,L["Faster AutoLoot"],L["You can loot faster than the Blizzard default autoloot speed. Enable this and give it a try, you will farm much faster!!"],L["It will also automatically enable the Interface->Controls->AutoLoot checkbox for you."],L["It has a message to advise when your bags are full, support TSM disenchant window and avoid getting disconected from server by multiple loot request with inventory full."])
setTooltip(tooltipTextOtroAutoLoot,L["Faster AutoLoot"], L["You already has another Fasterloot addon running."], L["You cannot use AutoScrap Faster AutoLoot untill you disable it."], L["AutoScrap Faster Autoloot includes faster autoloot, but also a message when your bags are full, support TSM disenchant window or avoid getting disconected from the server by multiple request of looting with inventory full. Give it a try!"])